﻿namespace TabsStudioAfterClose
{
    class CommandEventsListener
    {
        public event System.EventHandler ClosingSingleTabBefore;
        public event System.EventHandler ClosingSingleTabAfter;
        public event System.EventHandler ClosingSingleTabExtensionBefore;
        public event System.EventHandler ClosingSingleTabExtensionAfter;

        public CommandEventsListener(EnvDTE80.DTE2 dte_)
        {
            dte = dte_;
            events = dte.Events;
            commandEvents = events.get_CommandEvents(null, 0);
            commands = dte.Commands as EnvDTE80.Commands2;

            commandEvents.BeforeExecute += OnBeforeExecute;
            commandEvents.AfterExecute += OnAfterExecute;
        }

        public void Stop()
        {
            commandEvents.BeforeExecute -= OnBeforeExecute;
            commandEvents.AfterExecute -= OnAfterExecute;
        }

        private void OnBeforeExecute(string Guid, int ID, object CustomIn, object CustomOut, ref bool CancelDefault)
        {
            try
            {
                string name = GetCommandName(Guid, ID);
                if (name == "File.Close" || name == "Window.CloseDocumentWindow")
                {
                    if (ClosingSingleTabExtensionBefore != null)
                        ClosingSingleTabExtensionBefore(null, null);
                }
                if (name == "CloseTab" || name == "TabsStudio.Connect.CloseTab")
                {
                    if (ClosingSingleTabBefore != null)
                        ClosingSingleTabBefore(null, null);
                }
            }
            catch (System.Exception)
            {
            }
        }

        private void OnAfterExecute(string Guid, int ID, object CustomIn, object CustomOut)
        {
            try
            {
                string name = GetCommandName(Guid, ID);
                if (name == "File.Close" || name == "Window.CloseDocumentWindow")
                {
                    if (ClosingSingleTabExtensionAfter != null)
                        ClosingSingleTabExtensionAfter(null, null);
                }
                if (name == "CloseTab" || name == "TabsStudio.Connect.CloseTab")
                {
                    if (ClosingSingleTabAfter != null)
                        ClosingSingleTabAfter(null, null);
                }
            }
            catch (System.Exception)
            {
            }
        }

        // throw()
        private string GetCommandName(string Guid, int ID)
        {
            if (Guid == null)
                return "null";

            string result = "";
            if (commands != null)
            {
                try
                {
                    return commands.Item(Guid, ID).Name;
                }
                catch (System.Exception)
                {
                }
            }
            return result;
        }

        private EnvDTE80.DTE2 dte;
        private EnvDTE.Events events;
        private EnvDTE.CommandEvents commandEvents;
        private EnvDTE80.Commands2 commands;
    }
}
