﻿namespace TabsStudioAfterClose
{
    class Group
    {
        public Group(TabsStudioExt.Tabs tabs_, bool useActivateTabFocusWorkaround_)
        {
            tabs = tabs_;
            useActivateTabFocusWorkaround = useActivateTabFocusWorkaround_;
        }

        public void Activate()
        {
            Tab tab = GetSelectedTab();
            if (tab != null)
                tab.Activate();
        }

        public Tab GetSelectedTab()
        {
            foreach (TabsStudioExt.Tab tab in tabs.TabList)
            {
                if (tab.IsTabSelected)
                {
                    Tab result = new Tab(tab, useActivateTabFocusWorkaround);
                    if (!result.IsPreviewTab())
                        return result;
                }
            }
            return null;
        }

        public System.Windows.Point GetPosition()
        {
            return tabs.TabPanel2.PointToScreen(new System.Windows.Point(0, 0));
        }

        public bool IsEqual(Group item)
        {
            return tabs.TabPanel2 == item.tabs.TabPanel2;
        }

        private TabsStudioExt.Tabs tabs;
        private bool useActivateTabFocusWorkaround;
    }
}
